# CLEAR MEMORY
remove_design -all

# SET CELL LIBRARY
set target_library {/home/steinoe/CELL_LIB/sc/synopsys/slow/slow.db}
set link_library  {/home/steinoe/CELL_LIB/sc/synopsys/slow/slow.db}

lappend search_path {.}

# READ FILES
analyze -library WORK -format vhdl \
	{	mlite_pack.vhd \
		pc_next.vhd		mem_ctrl.vhd	control.vhd \
		reg_bank.vhd	bus_mux.vhd		alu.vhd \
		shifter.vhd		mult.vhd		pipeline.vhd \
		mlite_cpu.vhd
	}

# ELABORATE
elaborate mlite_cpu -architecture logic -library WORK

# CONSTRAINTS
create_clock clk -name clock -period 100

# MINIMIZING POWER
set_max_dynamic_power 0
set_max_total_power 0

# COMPILE
compile -map_effort medium -area_effort medium

# WRITE NETLIST
change_names -rules vhdl -hierarchy
set power_preserve_rtl_hier_names TRUE
write -hierarchy -format vhdl -output ../plasma_netlist.vhdl
