# CLEAR MEMORY
remove_design -all

# SET CELL LIBRARY
set target_library {/home/steinoe/CELL_LIB/sc/synopsys/slow/slow.db}
set link_library  {/home/steinoe/CELL_LIB/sc/synopsys/slow/slow.db}

lappend search_path {.}

# READ FILES
analyze -library WORK -format vhdl \
	{	/home/steinoe/zpu/zpu/hdl/example_medium/zpu_config_trace.vhd \
		/home/steinoe/zpu/zpu/hdl/zpu4/core/zpupkg.vhd \
		/home/steinoe/zpu/zpu/hdl/zpu4/core/zpu_core.vhd
	}

# ELABORATE
elaborate ZPU_CORE -architecture BEHAVE -library WORK -gate_clock

# CONSTRAINTS
create_clock clk -name clock -period 100

# CLOCK GATING
insert_clock_gating

# MINIMIZING POWER
set_max_dynamic_power 0
set_max_total_power 0

# COMPILE
compile -map_effort medium -area_effort medium

# WRITE NETLIST
change_names -rules vhdl -hierarchy
set power_preserve_rtl_hier_names TRUE
write -hierarchy -format vhdl -output ../zpu_core_clock_gated_netlist.vhdl
